SystemOrganization addCategory: #RatPack!
SystemOrganization addCategory: #'RatPack-Templating'!
SystemOrganization addCategory: #'RatPack-UI'!

HttpService subclass: #RPApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack'!

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:25'!
debug

	^ self runIn: #debug on: 4567 named: 'RatPack'! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/1/2012 18:50'!
errorPage

	^ '<!!DOCTYPE html>
<html>
<head>
<style type="text/css">
body {
	text-align: center;
	font-family: helvetica, arial;
	font-size: 22px;
	color: #888;
	margin: 20px;
}
pre {
	text-align: left;
	font-size: 12px;
}
.stackFrame {
	color: black;
	margin: 0;
}
</style>
</head>
<body>
<h2><%= 
	anException class name asString asHtml 
%>: <%= 
	anException messageText asString asHtml
%></h2>
<pre>
<% startContext := anException signalerContext
						ifNotNilDo: [:ctxt | ctxt]
						ifNil: [thisContext].
	(startContext stackOfSize: 100) do: [:ctxt || detailsStream | %>
		<span class=''stackFrame''>
		<% detailsStream := WriteStream on: (String new: 100).
			ctxt printDetails: detailsStream. %>
		<%= detailsStream contents %>	
		</span>
<% ]. %>
</pre>
</body>
</html>'
! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/1/2012 18:55'!
notFoundPage

	 ^ '<!!DOCTYPE html>
<html>
<head>
<style type="text/css">
body {
	text-align: center;
	font-family: helvetica,arial;
	font-size: 22px;
	color: #888;
	margin:20px
}
#c {
	margin: 0 auto;
	width: 500px;
	text-align: left
}
.methodName { color: black; }
.pragmaKey { color: green; }
.string { color: purple; }
.return { color: darkRed; }
</style>
</head>
<body>
<h2>The Rat Pack doesn&rsquo;t appear in this flick.</h2>
<div id="c">
Try this:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]
	
%>
</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase 

%></span>: <span class="string">''<%=

self request url

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello World''</span>
</pre>
</div>
<div id="c">
Or that:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]

%>: argument</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase

%></span>: <span class="string">''<%=

	self request pathParts isEmpty
		ifTrue: [''(.*)'']
		ifFalse: [(self request pathParts allButLast inject: '''' into: [:acc :next | acc, ''/'', next]), ''/%'']

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello ''</span>, argument
</pre>
</div>
<% self request pathParts ifNotEmpty: [ %>
<div id="c">
Or even this:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]

%>: argument</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase

%></span>: <span class="string">''<%=

	(self request pathParts allButLast inject: '''' into: [:acc :next | acc, ''/'', next]), ''/(.+)''

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello ''</span>, argument
</pre>
</div>
<% ]. %>
</body>
</html>'
! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
requestKey

	^ #rpRequest! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
responseKey

	^ #rpResponse! !

!RPApplication class methodsFor: 'accessing' stamp: 'tfel 2/1/2012 16:21'!
routes

	^ Array streamContents: [:stream |
		#(get: #put: #post: #delete: #patch: #head: #options: #trace: #connect:) do: [:verb |
			stream nextPutAll: (Pragma allNamed: verb from: self to: RPApplication)]]! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:24'!
run

	^ self runIn: #deployment on: 4567 named: 'RatPack'! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:24'!
runIn: mode on: aPort named: aString
	| service |
	service := self on: aPort named: aString.
	^ service
		mode: mode;
		onRequestDo: [:httpRequest | service processRequest: httpRequest];
		start;
		yourself
! !

!RPApplication class methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:05'!
services

	^ super services select: [:service | service isKindOf: self]! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:15'!
attachment: aFilename

	| attachmentHeader |
	attachmentHeader := 'attachment; filename="', (FileDirectory localNameFor: aFilename), '"'.
	self response headers: {'Content-Disposition' -> attachmentHeader}.
	(FileDirectory default mimeTypesFor: aFilename) ifNotNilDo: [:mimeTypes |
		self response headers: {'Content-Type' -> mimeTypes first}].
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:00'!
body
	
	^ self response contents
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:03'!
body: aStringOrStream

	self response contents: (aStringOrStream isStream
		ifTrue: [aStringOrStream]
		ifFalse: [ReadStream on: aStringOrStream]).! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:56'!
contentType

	^ (self threadLocal: self class responseKey) contentType! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:04'!
contentType: aString

	^ self response contentType: aString! !

!RPApplication methodsFor: 'templating' stamp: 'tfel 2/1/2012 18:59'!
est: aString
	"Renders the passed template string with the current application as receiver"
	^ RPEmbeddedSmalltalk render: aString for: self! !

!RPApplication methodsFor: 'templating' stamp: 'tfel 2/1/2012 18:59'!
fullEst: aString
	"Slower than #est, reifies the stack, but allows access to arguments and temps"
	^ RPEmbeddedSmalltalk render: aString in: thisContext sender! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers

	^ self response fields! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers: aDictionary

	self response fields addAll: aDictionary.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/1/2012 18:59'!
notFound
	self contentType: 'text/html'.
	self status: 404.
	^ self est: self class notFoundPage! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:20'!
params

	^ self request fields! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 19:01'!
processRequest: aHttpRequest
	| response |
	Processor activeProcess
		environmentAt: self class requestKey put: aHttpRequest;
		environmentAt: self class responseKey put: HttpResponse new.
	response := [self route: aHttpRequest] on: Error do: [:e | self serverError: e].
	response isString ifFalse: [response := ''].
	(self status = 404 and: [response isEmpty]) ifTrue: [response := self notFound].
	self body: response.
	^ self response
! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 12:17'!
redirectBack

	self redirectTo: self request referer.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/1/2012 11:50'!
redirectTo: aString

	self
		status: 302;
		contentType: MIMEDocument contentTypeHtml;
		body: 'Temporarily moved to: <A HREF="', aString, '">', aString, '</A>';
		headers: {'Location' -> aString asString copy. 'URI' -> aString asString copy}
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:40'!
request
	
	^ self threadLocal: self class requestKey
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
response
	
	^ self threadLocal: self class responseKey
! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 21:09'!
route: aHttpRequest
	| arguments result method |
	method := aHttpRequest method asLowercase asSymbol asMutator.
	arguments := (((Pragma allNamed: method from: self class to: RPApplication)
					collect: [:pragma || rx |
						rx := RxMatcher forString: ((pragma argumentAt: 1)
														copyReplaceAll: '%'
														with: '([^/]+)').
						(rx matches: aHttpRequest url)
							ifTrue: [pragma -> rx subexpressions allButFirst]
							ifFalse: [nil]])
					reject: [:assoc | assoc isNil])
					sortBy: [:a :b | a value size < b value size].
	arguments ifEmpty: [self status: 404. ^ ''].
	result := arguments first key method
				valueWithReceiver: self
				arguments: arguments first value.
	^ result isString ifTrue: [result] ifFalse: [self body]
! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/1/2012 18:59'!
serverError: anException

	self contentType: 'text/html'.
	self status: 500.
	self isDebugMode ifTrue: [anException signal].
	^ self fullEst: self class errorPage
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:57'!
status
	
	^ (self threadLocal: self class responseKey) statusCode asInteger
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
status: aSymbolOrInteger

	self response status: (aSymbolOrInteger isSymbol
		ifTrue: [aSymbolOrInteger]
		ifFalse: [HttpResponse statusSymbolFor: aSymbolOrInteger]).
! !

!RPApplication methodsFor: 'private' stamp: 'tfel 1/31/2012 13:56'!
threadLocal: aSymbol
	
	^ Processor activeProcess environmentAt: aSymbol ifAbsent: []
! !

SystemWindow subclass: #RPControlPanel
	instanceVariableNames: 'applicationIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack-UI'!

!RPControlPanel commentStamp: 'tfel 2/1/2012 16:05' prior: 0!
The RPControlPanel can be used to manage RPApplications.
Open it from the world menu or with:
	RPControlPanel open!

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:37'!
appClassChooserString

	^ 'Choose the application class' translated! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:38'!
appNameChooserString

	^ 'Application Name' translated! !

!RPControlPanel class methodsFor: 'constants' stamp: 'tfel 2/1/2012 15:39'!
defaultPort

	^ 4567! !

!RPControlPanel class methodsFor: 'constants' stamp: 'tfel 2/1/2012 15:35'!
initialWindowExtent

	^ 400@300! !

!RPControlPanel class methodsFor: 'menu key map' stamp: 'tfel 2/1/2012 16:11'!
menuKeyMap
	"Menu with always shown items in the first array, items that apply to a selected service 
	in the second. Items take the form {key . label . help . action}.
	If the label is a symbol, a label selector is assumed and an updating menu item is used.
	If key is nil, there will be no keybinding.
	For string labels, the keybinding is added in parens."
	^ #(
		#(
			$a 'Add' 'Add an application' addApplication
		)
		#(
			$s runningString 'Start/stop the application' toggleRunning
			$E 'Explore' 'Explore the application' exploreObject
			$m 'Set mode' 'Set the application mode' setMode
			$p 'Set port' 'Set the application port' setPort
			$n 'Set name' 'Set the application name' setName
			nil 'Remove' 'Remove the application' removeApplication
		)
	)! !

!RPControlPanel class methodsFor: 'instance creation' stamp: 'tfel 2/1/2012 10:01'!
open

	^ self new
		openInWorld;
		yourself! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:38'!
portString

	^ 'Port' translated! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 16:08'!
startString

	^ 'Start' translated, ' (s)'! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 16:09'!
stopString

	^ 'Stop' translated, ' (s)'! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:45'!
windowTitle

	^ 'RatPack ', 'Browser' translated, ' ', 'Window' translated! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 15:39'!
addApplication
	| labels class |
	labels := RPApplication withAllSubclasses collect: [:each | each name].
	class := (UIManager default
				chooseFrom: labels
				values: RPApplication withAllSubclasses
				lines: #()
				title: self class appClassChooserString) ifNil: [^ self].
	class
		runIn: #debug
		on: ((UIManager default
					request: self class portString
					initialAnswer: self class defaultPort asString) ifEmpty: [^ self]) asInteger
		named: ((UIManager default
					request: self class appNameChooserString
					initialAnswer: class name asString) ifEmpty: [^ self]).
	self applicationIndex: self applicationList size.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:04'!
applicationIndex
	"Answer the value of applicationIndex"

	^ applicationIndex! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:49'!
applicationIndex: anObject
	"Set the value of applicationIndex"

	applicationIndex := anObject.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 16:19'!
applicationInspect

	self selectedApplication ifNil: [^ ''].
	^ 'routes: ', self selectedApplication class routes printString, Character cr,
		'mode: ', self selectedApplication mode printString, Character cr! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:09'!
applicationList

	^ RPApplication services asOrderedCollection! !

!RPControlPanel methodsFor: 'menu' stamp: 'tfel 2/1/2012 15:59'!
applicationMenu: aMenu shifted: shift

	aMenu setTarget: self.
	self fillApplicationMenu: aMenu from: self class menuKeyMap first.
	self selectedApplication ifNotNil: [
		aMenu addLine.
		self fillApplicationMenu: aMenu from: self class menuKeyMap second].
	^ aMenu! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 15:40'!
buildApplicationDetail

	self
		addMorph: (PluggableTextMorph new
						on: self 
						text: #applicationInspect
						accept: nil
						readSelection: nil
						menu: nil;
						width: self width;
						height: self height / 2;
						topLeft: self height / 2 + self topLeft)
		fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).
! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 13:42'!
buildApplicationList

	self
		addMorph: (PluggableListMorph new
						on: self
						list: #applicationList
						selected: #applicationIndex
						changeSelected: #applicationIndex:
						menu: #applicationMenu:shifted:
						keystroke: #handleShortcut:;
						width: self width;
						height: self height / 2;
						topLeft: self topLeft)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.49)).! !

!RPControlPanel methodsFor: 'change reporting' stamp: 'tfel 2/1/2012 10:33'!
change

	self
		changed: #applicationList;
		changed: #applicationIndex;
		changed: #applicationInspect.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:26'!
exploreObject

	self selectedApplication explore.! !

!RPControlPanel methodsFor: 'menu' stamp: 'tfel 2/1/2012 16:08'!
fillApplicationMenu: aMenu from: aSpecificationList

	aSpecificationList groupsOf: 4 atATimeDo: [:key :label :help :action |
		label isSymbol
			ifFalse: [aMenu add: (key ifNil: [label] ifNotNil: [label, ' (', key, ')']) action: action]
			ifTrue: [aMenu addUpdating: label action: action].
		 aMenu balloonTextForLastItem: help].
! !

!RPControlPanel methodsFor: 'event handling' stamp: 'tfel 2/1/2012 16:05'!
handleShortcut: aChar
	| keyMap |
	keyMap := Dictionary new.
	self class menuKeyMap first groupsOf: 4 atATimeDo: [:key :label :help :action |
		keyMap at: key put: action].
	self selectedApplication ifNotNil: [
		self class menuKeyMap second groupsOf: 4 atATimeDo: [:key :label :help :action |
			keyMap at: key put: action]].
	self perform: (keyMap at: aChar ifAbsent: [#yourself]).! !

!RPControlPanel methodsFor: 'open/close' stamp: 'tfel 2/1/2012 15:35'!
initialExtent

	^ self class initialWindowExtent! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 15:47'!
initialize

	super initialize.
	self
		setLabel: self class windowTitle;
		applicationIndex: 0;
		layoutPolicy: ProportionalLayout new;
		buildApplicationList;
		buildApplicationDetail.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:52'!
removeApplication

	RPApplication removeService: self selectedApplication
										stop;
										yourself.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 15:47'!
runningString

	^ self selectedApplication
		ifNil: ['']
		ifNotNilDo: [:app |
			app isRunning ifTrue: [self class stopString] ifFalse: [self class startString]]! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:26'!
selectedApplication

	^ self applicationList at: self applicationIndex ifAbsent: []! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:57'!
setMode

	self selectedApplication
		mode: ((UIManager default
				chooseFrom: #(deployment debug)
				values: #(deployment debug)) ifNil: [^ self]).
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 15:39'!
setName

	self selectedApplication
		name: ((UIManager default
						request: self class appNameChooserString
						initialAnswer: self selectedApplication name) ifEmpty: [^ self]).
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 15:47'!
setPort

	self selectedApplication
		portNumber: ((UIManager default
						request: self class portString
						initialAnswer: self selectedApplication portNumber asString)
							ifEmpty: [^ self]) asInteger.
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:44'!
toggleRunning

	self selectedApplication isRunning
		ifTrue: [self selectedApplication stop]
		ifFalse: [self selectedApplication start].
	self change.! !

Object subclass: #RPEmbeddedSmalltalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack-Templating'!

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 18:42'!
convertToCode: aString
	"Converts the embedded smalltalk code into string concatenation with"
	| rs |
	rs := ReadStream on: aString.
	^ String streamContents: [:stream |
		"Initial code. Prepare the write stream to hold the rendered string"
		stream
			nextPutAll: '| r00t | r00t := WriteStream on: (String new: ';
			nextPutAll: (aString size / 2) floor printString;
			nextPutAll: ').';
			nextPut: Character cr.
		[stream
			nextPutAll: 'r00t nextPutAll: ';
			nextPutAll: (rs upToAll: '<%') printString;
			nextPut: $.;
			nextPut: Character cr.
		rs atEnd ifFalse: [| isInsert |
			(isInsert := rs peekFor: $=) ifTrue: [stream nextPutAll: 'r00t nextPutAll: ('].
			stream nextPutAll: (rs upToAll: '%>').
			isInsert ifTrue: [stream nextPutAll: ').'].
			stream nextPut: Character cr].
		rs atEnd] whileFalse.
		"Return rendered string"
		stream nextPutAll: 'r00t contents.']
! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 18:54'!
render: aString 

	^ self evaluate: aString for: nil! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 18:54'!
render: aString for: anObject

	^ Compiler new evaluate: (self convertToCode: aString) for: anObject logged: false! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 18:54'!
render: aString in: aContext

	^ Compiler new evaluate: (self convertToCode: aString) in: aContext to: aContext receiver! !
